//+
//+     Thanks extendedstatusbar, livehttpheaders and imagelikeopera !!!
//+
//+     This plugin monitor defined you HTTP response header of top level requesting document.
//+     Header defined in pref "extensions.headermonitor.header"
//+     (default monitoring header "Server")
//+     
//+
//+

var hmDefStatus = "none";
var hmCurStatus = hmDefStatus;
var hmSettingsHdr = "Server";
var hmDefmaxWidth = "250";
var hmDisplayIfExistHeader = true;
var hmDisplayHeaderName = false;

const HM_PREF_SERVICE = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefService);

const HM_PREF_BRANCH = HM_PREF_SERVICE.getBranch("extensions.headermonitor.");

const HM_OBSERV_SERVICE = Components.classes["@mozilla.org/observer-service;1"]
        .getService(Components.interfaces.nsIObserverService);


var hmBrowser = getBrowser();

eval('gBrowser.addTab =' + hmBrowser.addTab.toString().replace(
'if (!blank) {',
'   document.getElementById("hmStatus").collapsed = true; \
    if (!blank) { document.getElementById("hmStatus").collapsed = false;')
);

var hmPrefsObserver = {
    observe: function (aSubject, aTopic, aState) 
    {
        if (aTopic == "hm-load-prefs")
        {
		hmDefmaxWidth = HM_PREF_BRANCH.getIntPref("maxWidth");
		hmSettingsHdr = HM_PREF_BRANCH.getCharPref("header");
		hmDisplayIfExistHeader = HM_PREF_BRANCH.getBoolPref("DisplayIfExistHeader");
		hmDisplayHeaderName = HM_PREF_BRANCH.getBoolPref("DisplayHeaderName");
        }
    },
};
HM_OBSERV_SERVICE.addObserver(hmPrefsObserver, "hm-load-prefs", false);
HM_OBSERV_SERVICE.notifyObservers(hmPrefsObserver, "hm-load-prefs", false);

function hmTabSelect(aWebProgress)
{
  if(aWebProgress.isLoadingDocument) return;

//dumpall("aWebProgress.DOMWindow.headers",aWebProgress.DOMWindow.headers,1);

     if ('headers' in aWebProgress.DOMWindow) {
	const hmRespHeaders = aWebProgress.DOMWindow.headers.responseHeaders;
     if (hmRespHeaders[hmSettingsHdr]) { hmCurStatus = hmRespHeaders[hmSettingsHdr]; } 
				     else { hmCurStatus = hmDefStatus; }
	}
   else { hmCurStatus = hmDefStatus; }

    var hmStatus = document.getElementById("hmStatus");
        hmStatus.crop = "end";
        hmStatus.maxWidth = hmDefmaxWidth;
	hmStatus.tooltip = "none";


	if(hmDisplayHeaderName)	{ hmStatus.label = hmSettingsHdr + ": " + hmCurStatus;}
		else {hmStatus.label = hmCurStatus;}
	  hmStatus.tooltipText = hmStatus.label; 
	if(hmCurStatus == hmDefStatus && hmDisplayIfExistHeader ) { hmStatus.collapsed = true;}
		else {hmStatus.collapsed = false;}

//    dump("\n Select Tab!");

}
/*
function hmTest()
{
    dump("\n HIT!");
}
*/
	
const STATE_START =
  Components.interfaces.nsIWebProgressListener.STATE_START;

const STATE_STOP =
  Components.interfaces.nsIWebProgressListener.STATE_STOP;

function registerAdvStatusListener()
{
  advStatusListener.init();
  window.getBrowser().addProgressListener(advStatusListener , STATE_START);
}

function unregisterAdvStatusListener()
{
  advStatusListener.destroy();
  window.getBrowser().removeProgressListener(advStatusListener , STATE_STOP);
}


window.addEventListener("load",registerAdvStatusListener,false);
window.addEventListener("unload",unregisterAdvStatusListener,false);


var advStatusListener =
{
  hmStatus:	null,

  QueryInterface : function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsIXULBrowserWindow) ||
        aIID.equals(Components.interfaces.nsISupports) ||
        aIID.equals(Components.interfaces.nsIHttpNotify) ||
        aIID.equals(Components.interfaces.nsIObserver))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  init : function()
  {
    this.hmStatus	 = document.getElementById("hmStatus");

  },

  destroy : function()
  {
    this.hmStatus     = null;
  },

  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
  {

    if (aStateFlags & STATE_START) {
//	this.hmStatus.collapsed = true;
//	dump("\nstatus-start");
      }
    else if (aStateFlags & STATE_STOP) {
	
     if ('DOMWindow' in aWebProgress && 'headers' in aWebProgress.DOMWindow) {
	const hmRespHeaders = aWebProgress.DOMWindow.headers.responseHeaders;
	if (hmRespHeaders[hmSettingsHdr]) { hmCurStatus = hmRespHeaders[hmSettingsHdr]; } 
				     else { hmCurStatus = hmDefStatus; }
	}
	else {hmCurStatus = hmDefStatus;}

//dump("\nheader: " + hmCurStatus);

	if(hmDisplayHeaderName) { this.hmStatus.label = hmSettingsHdr +": " + hmCurStatus;}
		else {this.hmStatus.label = hmCurStatus;}
        this.hmStatus.tooltipText = this.hmStatus.label;

	if(hmCurStatus == hmDefStatus && hmDisplayIfExistHeader) { this.hmStatus.collapsed = true;}
		else {this.hmStatus.collapsed = false;}

//	aWebProgress.removeProgressListener(this);

//dumpall("aWebProgress",aWebProgress,1);
//dumpall("aWebProgress.DOMWindow.headers",aWebProgress.DOMWindow.headers,1);
//	dump("\nheader: " + hmHeaders.responseHeaders["Server"]); 
//	dump("\nstatus-stop: ");

    }

  },

  onProgressChange : function (a,b,c,d,e,f){},
  onLocationChange:function(a,b,c){  hmTabSelect(a);window.XULBrowserWindow.onLocationChange(a,b,c); },
  onStatusChange:function(a,b,c,d){window.XULBrowserWindow.onStatusChange(a,b,c,d);},
  onSecurityChange:function(a,b,c){window.XULBrowserWindow.onSecurityChange(a,b,c); },
  onLinkIconAvailable:function(a){}
}

// Utility function, dump an object by reflexion up to niv level (thanks LiveHttpHeaders!)
function dumpall(name,obj,niv) {
  if (!niv) niv=1;
  var dumpdict=new Object();

  dump ("\n\n-------------------------------------------------------\n");
  dump ("Dump of the object: " + name + " (" + niv + " levels)\n");
  dump ("Address: " + obj + "\n");
  dump ("Interfaces: ");
  for (var i in Components.interfaces) {
    try {
      obj.QueryInterface(Components.interfaces[i]);
      dump(""+Components.interfaces[i]+", ");
    } catch (ex) {}
  }
  dump("\n");
  _dumpall(dumpdict,obj,niv,"","");
  dump ("\n\n-------------------------------------------------------\n\n");
  
  for (i in dumpdict) {
    delete dumpdict[i];
  }
}
function _dumpall(dumpdict,obj,niv,tab,path) {

  if (obj in dumpdict) {
    dump(" (Already dumped)");
  } else {
    dumpdict[obj]=1;
    
    var i,r,str,typ;
    for (i in obj) {
      try {
        str = String(obj[i]).replace(/\n/g,"\n"+tab);
      } catch (ex) {
        str = String(ex);
      }
      try {
        typ = ""+typeof(obj[i]);
      } catch (ex) {
        typ = "unknown";
      }
      dump ("\n" + tab + i + " (" + typ + (path?", " + path:"") +"): " + str);
      if ((niv>1) && (typ=="object")) {
        _dumpall(dumpdict,obj[i],niv-1,tab+"\t",(path?path+"->"+i:i));
      }
    }
  }
}

function hmFullView() {
    var hmStatus = document.getElementById("hmStatus");

        if(hmStatus.maxWidth == 6666) { hmStatus.maxWidth = hmDefmaxWidth;}
		                 else { hmStatus.maxWidth = 6666; }
    hmStatus.collapsed = false;
//dump("\ntest");
}